std::set(3)

NAME
std::set -

SYNOPSIS

Detailed Description

  template<class _Key, class _Compare, class _Alloc> class std::set< _Key, _Compare, _Alloc >
Meets the requirements of a container, a reversible container, and an associative container (using unique keys).

Sets support bidirectional iterators.

Parameters:
    Key Type of key objects.
    Compare Comparison function object type, defaults to less<Key>.
    Alloc Allocator type, defaults to allocator<Key>.

Definition at line 107 of file stl_set.h.

  Public Types

typedef _Alloc allocator_type
typedef _Compare key_compare
typedef _Key key_type
typedef _Compare value_compare
typedef _Key value_type

typedef _Rep_type::const_iterator const_iterator
typedef _Key_alloc_type::const_pointer const_pointer
typedef _Key_alloc_type::const_reference const_reference
typedef _Rep_type::const_reverse_iterator const_reverse_iterator
typedef _Rep_type::difference_type difference_type
typedef _Rep_type::const_iterator iterator
typedef _Key_alloc_type::pointer pointer
typedef _Key_alloc_type::reference reference
typedef _Rep_type::const_reverse_iterator reverse_iterator
typedef _Rep_type::size_type size_type

  Public Member Functions
iterator begin () const
void clear ()
size_type count (const key_type &__x) const
bool empty () const
iterator end () const
void erase (iterator __first, iterator __last)
size_type erase (const key_type &__x)
void erase (iterator __position)
allocator_type get_allocator () const
template<class _InputIterator> void insert (_InputIterator __first, _InputIterator __last)
iterator insert (iterator __position, const value_type &__x)
std::pair< iterator, bool > insert (const value_type &__x)
key_compare key_comp () const
size_type max_size () const
set< _Key, _Compare, _Alloc > & operator= (const set< _Key, _Compare, _Alloc > &__x)
reverse_iterator rbegin () const
reverse_iterator rend () const
set (const set< _Key, _Compare, _Alloc > &__x)
template<class _InputIterator> set (_InputIterator __first, _InputIterator __last, const _Compare &__comp, const allocator_type &__a=allocator_type())
template<class _InputIterator> set (_InputIterator __first, _InputIterator __last)
set (const _Compare &__comp, const allocator_type &__a=allocator_type())
set ()
size_type size () const
void swap (set< _Key, _Compare, _Alloc > &__x)
value_compare value_comp () const

std::pair< const_iterator, const_iterator > equal_range (const key_type &__x) const
std::pair< iterator, iterator > equal_range (const key_type &__x)

const_iterator find (const key_type &__x) const
iterator find (const key_type &__x)

const_iterator lower_bound (const key_type &__x) const
iterator lower_bound (const key_type &__x)

const_iterator upper_bound (const key_type &__x) const
iterator upper_bound (const key_type &__x)

  Friends
template<class _K1, class _C1, class _A1> bool operator< (const set< _K1, _C1, _A1 > &, const set< _K1, _C1, _A1 > &)
template<class _K1, class _C1, class _A1> bool operator== (const set< _K1, _C1, _A1 > &, const set< _K1, _C1, _A1 > &)

Member Typedef Documentation

  typedef _Key key_type

Public typedefs.

Definition at line 120 of file stl_set.h.

  typedef _Key_alloc_type::pointer pointer

Iterator-related typedefs.

Definition at line 137 of file stl_set.h.

Constructor & Destructor Documentation

  set () [inline]

Default constructor creates no elements.

Definition at line 154 of file stl_set.h.

  set (const _Compare & __comp, const allocator_type & __a = allocator_type()) [inline, explicit]

Default constructor creates no elements.

Parameters:
    comp Comparator to use.
    a Allocator to use.

Definition at line 164 of file stl_set.h.

  set (_InputIterator __first, _InputIterator __last) [inline]

Builds a set from a range.

Parameters:
    first An input iterator.
    last An input iterator.

Create a set consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 178 of file stl_set.h.

  set (_InputIterator __first, _InputIterator __last, const _Compare & __comp, const allocator_type & __a = allocator_type()) [inline]

Builds a set from a range.

Parameters:
    first An input iterator.
    last An input iterator.
    comp A comparison functor.
    a An allocator object.

Create a set consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 194 of file stl_set.h.

  set (const set< _Key, _Compare, _Alloc > & __x) [inline]

Set copy constructor.

Parameters:
    x A set of identical element and allocator types.

The newly-created set uses a copy of the allocation object used by x.

Definition at line 207 of file stl_set.h.

Member Function Documentation

  iterator begin () const [inline]

Returns a read/write iterator that points to the first element in the set. Iteration is done in ascending order according to the keys.

Definition at line 244 of file stl_set.h.

  void clear () [inline]

Erases all elements in a set. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 411 of file stl_set.h.

  size_type count (const key_type & __x) const [inline]

Finds the number of elements.

Parameters:
    x Element to located.

Returns:
    Number of elements with specified key.

This function only makes sense for multisets; for set the result will either be 0 (not present) or 1 (present).

Definition at line 425 of file stl_set.h.

  bool empty () const [inline]

Returns true if the set is empty.

Definition at line 275 of file stl_set.h.

  iterator end () const [inline]

Returns a read/write iterator that points one past the last element in the set. Iteration is done in ascending order according to the keys.

Definition at line 252 of file stl_set.h.

  std::pair<iterator, iterator> equal_range (const key_type & __x) [inline]

Finds a subsequence matching given key.

Parameters:
    x Key to be located.

Returns:
    Pair of iterators that possibly points to the subsequence matching given key.

This function is equivalent to

    std::make_pair(c.lower_bound(val),
                   c.upper_bound(val))

 (but is faster than making the calls separately).

This function probably only makes sense for multisets.

Definition at line 505 of file stl_set.h.

  void erase (iterator __first, iterator __last) [inline]

Erases a [first,last) range of elements from a set.

Parameters:
    first Iterator pointing to the start of the range to be erased.
    last Iterator pointing to the end of the range to be erased.

This function erases a sequence of elements from a set. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 401 of file stl_set.h.

  size_type erase (const key_type & __x) [inline]

Erases elements according to the provided key.

Parameters:
    x Key of element to be erased.

Returns:
    The number of elements erased.

This function erases all the elements located by the given key from a set. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 386 of file stl_set.h.

  void erase (iterator __position) [inline]

Erases an element from a set.

Parameters:
    position An iterator pointing to the element to be erased.

This function erases an element, pointed to by the given iterator, from a set. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 371 of file stl_set.h.

  iterator find (const key_type & __x) [inline]

Tries to locate an element in a set.

Parameters:
    x Element to be located.

Returns:
    Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( end() ) iterator.

Definition at line 443 of file stl_set.h.

  allocator_type get_allocator () const [inline]

Returns the allocator object with which the set was constructed.

Definition at line 236 of file stl_set.h.

  void insert (_InputIterator __first, _InputIterator __last) [inline]

A template function that attemps to insert a range of elements.

Parameters:
    first Iterator pointing to the start of the range to be inserted.
    last Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 358 of file stl_set.h.

  iterator insert (iterator __position, const value_type & __x) [inline]

Attempts to insert an element into the set.

Parameters:
    position An iterator that serves as a hint as to where the element should be inserted.
    x Element to be inserted.

Returns:
    An iterator that points to the element with key of x (may or may not be the element passed in).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument insert() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See http://gcc.gnu.org/onlinedocs/libstdc++/23_containers/howto.html#4 for more on 'hinting'.

Insertion requires logarithmic time (if the hint is not taken).

Definition at line 345 of file stl_set.h.

  std::pair<iterator,bool> insert (const value_type & __x) [inline]

Attempts to insert an element into the set.

Parameters:
    x Element to be inserted.

Returns:
    A pair, of which the first element is an iterator that points to the possibly inserted element, and the second is a bool that is true if the element was actually inserted.

This function attempts to insert an element into the set. A set relies on unique keys and thus an element is only inserted if it is not already present in the set.

Insertion requires logarithmic time.

Definition at line 318 of file stl_set.h.

References pair::first, and pair::second.

  key_compare key_comp () const [inline]

Returns the comparison object with which the set was constructed.

Definition at line 228 of file stl_set.h.

References _Rb_tree::key_comp().

  iterator lower_bound (const key_type & __x) [inline]

Finds the beginning of a subsequence matching given key.

Parameters:
    x Key to be located.

Returns:
    Iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Definition at line 464 of file stl_set.h.

  size_type max_size () const [inline]

Returns the maximum size of the set.

Definition at line 285 of file stl_set.h.

  set<_Key,_Compare,_Alloc>& operator= (const set< _Key, _Compare, _Alloc > & __x) [inline]

Set assignment operator.

Parameters:
    x A set of identical element and allocator types.

All the elements of x are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 218 of file stl_set.h.

References set::_M_t.

  reverse_iterator rbegin () const [inline]

Returns a read/write reverse iterator that points to the last element in the set. Iteration is done in descending order according to the keys.

Definition at line 261 of file stl_set.h.

  reverse_iterator rend () const [inline]

Returns a read-only (constant) reverse iterator that points to the last pair in the map. Iteration is done in descending order according to the keys.

Definition at line 270 of file stl_set.h.

  size_type size () const [inline]

Returns the size of the set.

Definition at line 280 of file stl_set.h.

  void swap (set< _Key, _Compare, _Alloc > & __x) [inline]

Swaps data with another set.

Parameters:
    x A set of the same element and allocator types.

This exchanges the elements between two sets in constant time. (It is only swapping a pointer, an integer, and an instance of the Compare type (which itself is often stateless and empty), so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(s1,s2) will feed to this function.

Definition at line 300 of file stl_set.h.

References set::_M_t.

Referenced by std::swap().

  iterator upper_bound (const key_type & __x) [inline]

Finds the end of a subsequence matching given key.

Parameters:
    x Key to be located.

Returns:
    Iterator pointing to the first element greater than key, or end().

Definition at line 480 of file stl_set.h.

  value_compare value_comp () const [inline]

Returns the comparison object with which the set was constructed.

Definition at line 232 of file stl_set.h.

Author

Generated automatically by Doxygen for libstdc++ from the source code.